#include "config.h"
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include "wdog.h"

#define WDOG_PATH "/dev/watchdog"

static int
wdog_handle(unsigned int cmd, const char *id, unsigned int t)
{
    wdog_cmd_t wc;
    int fd;
    ssize_t len;
    ssize_t wc_len = sizeof(wdog_cmd_t);

    memset(&wc, 0, wc_len);
    wc.cmd = cmd;
    strncpy(wc.id, id, WDOG_ID_MAXLEN);
    wc.tm = t;

    if ((fd = open(WDOG_PATH, O_WRONLY)) >= 0) {
	len = write(fd, &wc, wc_len);
	close(fd);
	errno = len;
	if (len == wc_len) {
	    return 0;
	}
    }
    return 1;
}

int
wdog_register(const char *id, unsigned int timeout)
{
    return wdog_handle(WDOG_CMD_REGISTER, id, timeout);
}

int
wdog_kick(const char *id, unsigned int timeout)
{
    return wdog_handle(WDOG_CMD_REGISTER, id, timeout);
}

int
wdog_unregister(const char *id)
{
    return wdog_handle(WDOG_CMD_UNREGISTER, id, 0);
}
